﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows .Forms;
using System.Windows.Forms.Design ;
using System.Diagnostics;
using System.Threading;


namespace KML处理专家
{
   

  public  class filesearch
    {
       
        public void directorytotree(string filename, TreeNode node)
        {
            DirectoryInfo folder = new DirectoryInfo(filename);
            node.Text = folder.Name;
            node.Tag = folder.FullName;
            FileInfo[] chldFiles = folder.GetFiles("*.*");
            foreach (FileInfo chlFile in chldFiles)
            {
                TreeNode chldNode = new TreeNode();
                chldNode.Text = chlFile.Name;
                chldNode.Tag = chlFile.FullName;
                node.Nodes.Add(chldNode);
            }
            DirectoryInfo[] chldFolders = folder.GetDirectories();
            foreach (DirectoryInfo chldFolder in chldFolders)
            {
                TreeNode chldNode = new TreeNode();
                chldNode.Text = folder.Name;
                chldNode.Tag = folder.FullName;
                node.Nodes.Add(chldNode);
                directorytotree(chldFolder.FullName, chldNode);
            }

        }
        public static void SearchFile(string path, string file, ref string result) 
        { DirectoryInfo di = new DirectoryInfo(path); FileInfo[] fis = di.GetFiles();
            foreach (FileInfo fi in fis) 
            { if (fi.Name == file) 
            { result = fi.FullName; return; } 
            } 
            DirectoryInfo[] dis = di.GetDirectories(); 
            foreach (DirectoryInfo dinfo in dis) 
            { 
                SearchFile(dinfo.Name, file, ref result);
            } 
        }
      public List<FileInfo> lfileinfo = new List<FileInfo>();
      public List<string> lfilepath = new List<string>();
        public  List<FileInfo> SearchFileByExtension(string path, string[] extension)//搜索文件夹下的所有相同后缀名的文件,如".kml"
        {
            
            DirectoryInfo di = new DirectoryInfo(path); 
            FileInfo[] fis = di.GetFiles();
           
            foreach (FileInfo fi in fis)
            {
                for(int i=0;i<extension.Length;i++)
                {
                    if(extension[i].Trim ()!="")
                    {
                if (fi.Name.EndsWith(extension[i]))
                {
                    lfileinfo.Add(fi);
                  
                }
                    }
                }              
            }
            DirectoryInfo[] dis = di.GetDirectories();
            foreach (DirectoryInfo dinfo in dis)
            {
                SearchFileByExtension(dinfo.FullName, extension);
            }
            return lfileinfo;
        }

        public List<string> SearchFileByExtensionReturnFileName(string path, string[] extension)//搜索文件夹下的所有相同后缀名的文件,如".kml"
        {

            DirectoryInfo di = new DirectoryInfo(path);
            FileInfo[] fis = di.GetFiles();

            foreach (FileInfo fi in fis)
            {
                for (int i = 0; i < extension.Length; i++)
                {
                    if (extension[i].Trim() != "")
                    {
                        if (fi.Name.EndsWith(extension[i]))
                        {
                            lfilepath.Add(fi.FullName);

                        }
                    }
                }
            }
            DirectoryInfo[] dis = di.GetDirectories();
            foreach (DirectoryInfo dinfo in dis)
            {
                SearchFileByExtension(dinfo.FullName, extension);
            }
            return lfilepath;
        }

        int j = 0;
       
        public int SearchFiletoaccess(string filefoldera, string[] option,DataGridView dgv,string accesspath,TextBox t)
        {
             WindowsApplication1.KML转换类 km = new WindowsApplication1.KML转换类();
            //DataGridViewColumn d = new DataGridViewColumn();
            //dgv.Columns.Add(d);
            //dgv.Columns.Add(d);
                DirectoryInfo di = new DirectoryInfo(filefoldera);

                FileInfo[] fis = di.GetFiles();
                bool isrun = false;
                foreach (FileInfo fi in fis)
                {


                    if (fi.FullName.ToLower().EndsWith(".kmz"))
                    {


                        //string s= Path.ChangeExtension(fi.FullName, ".zip");
                        string directoryname = Path.GetDirectoryName(fi.FullName);
                        UnZipDir uzd = new UnZipDir(fi.FullName, directoryname);
                        //FileInfo f = new FileInfo( directoryname + "//doc.kml");
                        char[] delimiterChars = { '.', '\\' };
                        string[] Mystr = fi.FullName.Split(delimiterChars);
                        string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”
                        System.IO.File.Delete(directoryname + "//" + sheetName + ".kml");
                        System.IO.File.Move(directoryname + "//doc.kml", directoryname + "//" + sheetName + ".kml");
                        FileInfo f1 = new FileInfo(directoryname + "//" + sheetName + ".kml");

                        //if (f1.Length < 1024 * 1024 * 30)
                        //{                                                        
                        km.kmlpointtoaccess(System.IO.File.ReadAllText(directoryname + "//" + sheetName + ".kml"), accesspath);
                        j++;

                    }
                    //}                   


                    if (fi.FullName.ToLower().EndsWith(".kml"))
                    {
                        string directoryname = Path.GetDirectoryName(fi.FullName);

                        char[] delimiterChars = { '.', '\\' };
                        string[] Mystr = fi.FullName.Split(delimiterChars);
                        string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”
                        //if (fi.Length < 1024 * 1024 * 30)
                        //{                                            
                        km.kmlpointtoaccess(System.IO.File.ReadAllText(directoryname + "//" + sheetName + ".kml"), accesspath);
                        j++;
                        //}

                    }
                }        
                DirectoryInfo[] dis = di.GetDirectories();

                foreach (DirectoryInfo dinfo in dis)
                {
                    SearchFiletoaccess(dinfo.FullName , option,dgv,accesspath,t);
                   
                }
                t.Text = j.ToString();
                return j;
                             
            }

        public int SearchKMLFileandcut(string filefoldera, string[] option, DataGridView dgv, string accesspath, TextBox t,string savepath)
        {
            WindowsApplication1.KML转换类 km = new WindowsApplication1.KML转换类();
            //DataGridViewColumn d = new DataGridViewColumn();
            //dgv.Columns.Add(d);
            //dgv.Columns.Add(d);
            DirectoryInfo di = new DirectoryInfo(filefoldera);

            FileInfo[] fis = di.GetFiles();
            bool isrun = false;
            foreach (FileInfo fi in fis)
            {


                //if (fi.FullName.ToLower().EndsWith(".kmz"))
                //{


                //    //string s= Path.ChangeExtension(fi.FullName, ".zip");
                //    string directoryname = Path.GetDirectoryName(fi.FullName);
                //    UnZipDir uzd = new UnZipDir(fi.FullName, directoryname);
                //    //FileInfo f = new FileInfo( directoryname + "//doc.kml");
                //    char[] delimiterChars = { '.', '\\' };
                //    string[] Mystr = fi.FullName.Split(delimiterChars);
                //    string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”
                //    System.IO.File.Delete(directoryname + "//" + sheetName + ".kml");
                //    System.IO.File.Move(directoryname + "//doc.kml", directoryname + "//" + sheetName + ".kml");
                //    FileInfo f1 = new FileInfo(directoryname + "//" + sheetName + ".kml");

                //    //if (f1.Length < 1024 * 1024 * 30)
                //    //{                                                        
                //    km.kmlpointtoaccess(System.IO.File.ReadAllText(directoryname + "//" + sheetName + ".kml"), accesspath);
                //    j++;

                //}
                ////}                   


                if (fi.FullName.ToLower().EndsWith(".kml"))
                {
                    if (fi.Length > 1024 * 1024/3)
                    {
                        string directoryname = Path.GetDirectoryName(fi.FullName);

                        char[] delimiterChars = { '.', '\\' };
                        string[] Mystr = fi.FullName.Split(delimiterChars);
                        string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”


                        WindowsFormsApplication1.CutFile.CutFiles(fi.FullName, "1", "150000", savepath, sheetName);

                    }
                    else
                    { 
                        char[] delimiterChars = { '.', '\\' };
                        string[] Mystr = fi.FullName.Split(delimiterChars);
                        string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”
                        System.IO.File.Copy(fi.FullName,savepath + "\\"+sheetName + ".kml");

                    }
                   
                 
                }
            }
            DirectoryInfo[] dis = di.GetDirectories();

            foreach (DirectoryInfo dinfo in dis)
            {
                SearchKMLFileandcut(dinfo.FullName, option, dgv, accesspath, t,savepath);

            }
            t.Text = j.ToString();
            return j;

        }

        int kmlandkmznumber = 0;
        public int howmanykmlandkmz(string filefoldera)
        {
           
            DirectoryInfo di = new DirectoryInfo(filefoldera);

            FileInfo[] fis = di.GetFiles();
            
            foreach (FileInfo fi in fis)
            {
                if (fi.FullName.ToLower ().EndsWith(".kml") || fi.FullName.ToLower ().EndsWith(".kmz"))
                {
                    kmlandkmznumber++;
                  

                }
            }
            DirectoryInfo[] dis = di.GetDirectories();

            foreach (DirectoryInfo dinfo in dis)
            {
                howmanykmlandkmz(dinfo.FullName);

            }
            return kmlandkmznumber;
        }
        int p = 0;
        public int SearchFiletodatagridview(string filefoldera, string[] option, DataGridView dgv)
        {
            
            WindowsApplication1.KML转换类 km = new WindowsApplication1.KML转换类();
            //DataGridViewColumn d = new DataGridViewColumn();
            //dgv.Columns.Add(d);
            //dgv.Columns.Add(d);
            DirectoryInfo di = new DirectoryInfo(filefoldera);

            FileInfo[] fis = di.GetFiles();
            foreach (FileInfo fi in fis)
            {


                if (fi.FullName.ToLower ().EndsWith(".kmz"))
                {


                    //string s= Path.ChangeExtension(fi.FullName, ".zip");
                    string directoryname = Path.GetDirectoryName(fi.FullName);
                    UnZipDir uzd = new UnZipDir(fi.FullName, directoryname);
                    //FileInfo f = new FileInfo( directoryname + "//doc.kml");
                    char[] delimiterChars = { '.', '\\' };
                    string[] Mystr = fi.FullName.Split(delimiterChars);
                    string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”
                    System.IO.File.Delete(directoryname + "//" + sheetName + ".kml");
                    System.IO.File.Move(directoryname + "//doc.kml", directoryname + "//" + sheetName + ".kml");
                    FileInfo f1 = new FileInfo(directoryname + "//" + sheetName + ".kml");

                    if (f1.Length < 1024 * 1024 * 3)
                    {
                        km.kmlpointtoexcel(System.IO.File.ReadAllText(directoryname + "//" + sheetName + ".kml"), directoryname + "\\" + sheetName + ".xls");
                       p++;
                    }

                }
                //if (fi.FullName.EndsWith(option[0].ToString()) || fi.FullName.EndsWith(option[1].ToString()))
                //{

                //    DataGridViewRow dr = new DataGridViewRow();
                //    //dr.Cells[0].Value = fi.FullName;
                //    //dr.Cells[1].Value = fi.Length;
                //    //dr.CreateCells(dgv);
                //    dgv.Rows.Add(dr);
                //    //dgv.Rows[j].Cells[0].Value = fi.FullName;
                //    //dgv.Rows[j].Cells[1].Value = fi.Length;
                //    dgv[0, j].Value = fi.FullName;

                //    dgv[1, j].Value = fi.Length;
                //    j++;

                //}

                if (fi.FullName.ToLower().EndsWith(".kml"))
                {
                    string directoryname = Path.GetDirectoryName(fi.FullName);

                    char[] delimiterChars = { '.', '\\' };
                    string[] Mystr = fi.FullName.Split(delimiterChars);
                    string sheetName = Mystr[Mystr.Length - 2];// 没有扩展名的文件名 “Default”
                    if (fi.Length < 1024 * 1024 * 10)
                    {

                        km.kmlpointtoexcel(System.IO.File.ReadAllText(fi.FullName), directoryname + "\\" + sheetName + ".xls");
                        p++;

                    }

                }
            }
            DirectoryInfo[] dis = di.GetDirectories();
            foreach (DirectoryInfo dinfo in dis)
            {
                SearchFiletodatagridview(dinfo.FullName, option, dgv);

               
            }
          
            return p;
            //MessageBox.Show("ok");
        }
    }
}
